SystemOrganization addCategory: #'EsAndEM-Core'!
SystemOrganization addCategory: #'EsAndEm-Debugging'!
SystemOrganization addCategory: #'EsAndEm-Tests'!

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 7/12/2010 21:42'!
closure: aBlockClosure
	closureOrNil := aBlockClosure! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:54'!
materializeWith: aMaterializer
	^ aMaterializer materializeContext: self! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 9/8/2008 07:44'!
serializeWith: aSerializer
	^ aSerializer serializeMethodContext: self! !

!Float methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:32'!
materializeWith: aMaterializer
	^ self! !

!Float methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 19:51'!
serializeWith: aSerializer
	^ aSerializer serializeFloat: self! !

!Dictionary methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 16:10'!
encodeWith: anEncoder
	self class = Dictionary 
		ifTrue: [anEncoder encodeDictionary: self]
		ifFalse: [super encodeWith: anEncoder].! !

!Dictionary methodsFor: '*esandem-indexing' stamp: 'cwp 8/9/2011 14:41'!
indexOf: anObject do: aBlock
	self indexOf: anObject ifPresent: aBlock ifAbsent: aBlock! !

!Dictionary methodsFor: '*esandem-indexing' stamp: 'cwp 8/9/2011 14:40'!
indexOf: anObject ifPresent: pBlock ifAbsent: aBlock
	| id |
	(self includesKey: anObject)
		ifTrue: [ 
			id := self at: anObject.
			pBlock value: id ]
		ifFalse: [ 
			id := self size + 1.
			self at: anObject put: id.
			aBlock value: id ]! !

!Dictionary methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 16:09'!
materializeWith: aMaterializer
	^ aMaterializer materializeDictionary: self! !

!Dictionary methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 16:09'!
serializeWith: aSerializer
	^ aSerializer serializeDictionary: self! !

!Bag methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 15:14'!
encodeWith: anEncoder
	^ anEncoder encodeBag: self! !

!Bag methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 15:20'!
materializeWith: aMaterializer
	^ aMaterializer materializeBag: self! !

!Bag methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 15:11'!
serializeWith: aSerializer
	aSerializer serializeBag: self! !

!UndefinedObject methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:09'!
materailizeWith: aMaterializer
	^ self! !

!UndefinedObject methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 19:36'!
serializeWith: aSerializer
	^ aSerializer serializeSingleton: self! !

!Integer methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:34'!
materializeWith: aMaterializer
	^ self! !

!Integer methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 16:09'!
serializeWith: aSerializer
	aSerializer serializeInteger: self! !

!IdentityDictionary methodsFor: '*esandem-dispatch' stamp: 'cwp 10/3/2011 16:06'!
encodeWith: anEncoder
	anEncoder encodeIdentityDictionary: self! !

!CompiledMethod methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 10:26'!
serializeWith: aSerializer
	aSerializer serializeExternal: self! !

!Behavior methodsFor: '*esandem-accessing' stamp: 'cwp 9/9/2010 19:51'!
smFormatCode
	self isFixed ifTrue: [^ 1].		"named pointers only"
	self isPointers ifTrue: [^ 2].		"named pointers + index pointers"
	self isBytes ifTrue: [^ 3].		"bytes"
	self isWords ifTrue: [^ 4].		"words"
	self isWeak ifTrue: [^ 5].		"weak"
	self error: 'Unsupported class format.'! !

!Class methodsFor: '*esandem-dispatch' stamp: 'cwp 8/9/2011 15:14'!
encodeWith: anEncoder
	anEncoder encodeClass: self! !

!Class methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:36'!
materializeWith: aMaterializer
	^ aMaterializer materializeClass: self! !

!Class methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 23:04'!
serializeWith: aSerializer
	aSerializer serializeClass: self! !

!ByteString methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 21:49'!
serializeWith: aSerializer
	aSerializer serializeUtf8String: self! !

!String methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:31'!
materializeWith: anObject
	^ self! !

!Object methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 11:42'!
encodeWith: anEncoder
	anEncoder encodeObject: self! !

!Object methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 11:45'!
materializeWith: aMaterializer
	^ aMaterializer materializeObject: self! !

!Object methodsFor: '*esandem-public' stamp: 'cwp 8/21/2011 22:35'!
rematerialize
	^ self serialize materialize! !

!Object methodsFor: '*esandem-public' stamp: 'cwp 8/23/2010 22:32'!
serialize
	^ SMArchive with: self! !

!Object methodsFor: '*esandem-dispatch' stamp: 'cwp 9/2/2008 00:35'!
serializeWith: aSerializer
	aSerializer serializeObject: self! !

Object subclass: #SMArchive
	instanceVariableNames: 'bytes external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMArchive class methodsFor: 'instance creation' stamp: 'cwp 8/26/2010 10:02'!
bytes: aByteArray external: anArray
	^ self basicNew
		initializeWithBytes: aByteArray external: anArray;
		yourself! !

!SMArchive class methodsFor: 'serializing' stamp: 'cwp 10/3/2011 14:58'!
with: anObject
	| ext stream |
	stream := (ByteArray new: 100) writing.
	ext := SMSerializer serialize: anObject on: stream.
	^ self bytes: stream contents external: ext! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 11/4/2008 00:04'!
base64
	^ (Base64MimeConverter mimeEncode: self bytes readStream) contents! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2008 23:57'!
bytes
	^ bytes! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2008 21:32'!
digest
	| sha |
	sha := SecureHashAlgorithm new.
	^ (sha hashMessage: bytes) printStringHex asLowercase! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:01'!
external
	^ external! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:02'!
initializeWithBytes: aByteArray external: anArray
	self initialize.
	bytes := aByteArray.
	external := anArray! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 10/3/2011 14:52'!
materialize
	^ (SMMaterializer on: bytes reading)
		external: external;
		materialize! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 10/3/2011 14:57'!
materializeFrom: first
	|  last subset in object |
	last := bytes size.
	subset := bytes copyFrom: first to: last.
	in := subset reading.
	object := (SMMaterializer on: in) 
		external: external;
		materialize.
	^ {object. in position + first}
	! !

Object subclass: #SMCodec
	instanceVariableNames: 'stream classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMCodec methodsFor: 'initialize-release' stamp: 'cwp 9/9/2010 23:02'!
initializeWithStream: aStream
	self initialize.
	stream := aStream! !

SMCodec subclass: #SMDecoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMDecoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2011 15:08'!
stream: aStream
	^ self basicNew initializeWithStream: aStream! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 9/9/2010 20:15'!
classNamed: aSymbol format: anInteger instVars: anArray
	| escape class |
	escape := [^ self stubNamed: aSymbol format: anInteger instVars: anArray].
	class := Smalltalk at: aSymbol ifAbsent: escape.
	class smFormatCode = anInteger ifFalse: escape.
	anInteger < 3 ifTrue: [class allInstVarNames = anArray ifFalse: escape].
	^ class! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/7/2011 15:41'!
decode
	| type |
	type := self getType.
	type < 241 ifTrue: [^ type].
	type = 255 ifTrue: [^ self decodeArrow].
	type = 254 ifTrue: [^ self decodeExternal].
	type = 253 ifTrue: [^ self decodeClass].
	type = 252 ifTrue: [^ self decodeObject].
	type = 251 ifTrue: [^ self decodeUtf8String].
	type = 250 ifTrue: [^ self decodeUtf16String].
	type = 249 ifTrue: [^ self decodeSymbol].
	type = 248 ifTrue: [^ self decodeLargeNegativeInteger].
	type = 247 ifTrue: [^ self decodeSmallNegativeInteger].
	type = 246 ifTrue: [^ self decodeSmallPositiveInteger].
	type = 245 ifTrue: [^ self decodeLargePositiveInteger].
	type = 244 ifTrue: [^ self decodeFloat].
	type = 243 ifTrue: [^ self decodeContext].
	type = 242 ifTrue: [^ self decodeLibrary].
	type = 241 ifTrue: [^ self decodeCompact].
! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/8/2011 23:43'!
decodeArray
	^ Array new: self decode.! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:43'!
decodeArrow
	^ SMArrow with: self decode.! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/3/2011 15:16'!
decodeBag
	^ Bag new! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:32'!
decodeByte
	^ self getByte! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/8/2011 23:43'!
decodeByteArray
	^ ByteArray new: self decode! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/9/2011 15:16'!
decodeClass
	| id names code class |
	id := self decode.
	^ id isInteger
		ifTrue: [classes at: id]
		ifFalse:
			[code := self decode.
			code < 3 ifTrue:
				[names := Array new:  self decode.
				1 to: names size do: [:index | names at: index put: self decode]].
			class := self classNamed: id format: code instVars: names.
			classes add: class]! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/7/2011 15:49'!
decodeContext
	| frameSize |
	frameSize := self decode.
	^ MethodContext smBasicNew: frameSize.! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 12:40'!
decodeDictionary
	^ Dictionary new
! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:42'!
decodeExternal
	^ SMExternal with: self decode.! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:45'!
decodeFloat
	^ self getFloat! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/3/2011 16:12'!
decodeIdentityDictionary
	^ IdentityDictionary new
! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/3/2011 16:27'!
decodeInterval
	^ Interval new! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:42'!
decodeLargeNegativeInteger
	| size |
	size := self decode.
	^ (self getIntegerOfSize: size) negated! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:41'!
decodeLargePositiveInteger
	| size |
	size := self decode.
	^ self getIntegerOfSize: size! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/8/2011 23:41'!
decodeLibrary
	| type |
	type := self decode.
	type = 1 ifTrue: [^ nil].
	type = 2 ifTrue: [^ true].
	type = 3 ifTrue: [^ false].
	type = 4 ifTrue: [^ self decodeArray].
	type = 5 ifTrue: [^ self decodeBag].
	type = 6 ifTrue: [^ self decodeByteArray].
	type = 7 ifTrue: [^ self decodeDictionary].
	type = 8 ifTrue: [^ self decodeIdentityDictionary].
	type = 9 ifTrue: [^ self decodeInterval].
	type = 10 ifTrue: [^ self decodeOrderedCollection].
	type = 11 ifTrue: [^ self decodeSet].
	self error: 'unrecognized library type'! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:55'!
decodeObject
	| theClass |
	theClass := self decode.
	^ theClass isVariable 
		ifTrue: [ theClass basicNew: self decode]
		ifFalse: [ theClass basicNew ].
	! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/4/2011 11:29'!
decodeOrderedCollection
	^ OrderedCollection new! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 12:28'!
decodeSet
	^ Set new! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 13:07'!
decodeSingleton
	^ self getSingleton! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:10'!
decodeSmallNegativeInteger
	^ self getSmallInteger negated! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:10'!
decodeSmallPositiveInteger
	^ self getSmallInteger! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:30'!
decodeSymbol
	^ self decodeUtf8String asSymbol! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:42'!
decodeUtf16String
	| size |
	size := self decode.
	^ self getUtf16StringOfSize: size.
	! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/7/2011 16:11'!
decodeUtf8String
	| size |
	size := self decode.
	^ self getUtf8StringOfSize: size! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:30'!
getByte
	^ stream next! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 10/3/2011 14:53'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream get ]! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 10/3/2011 14:52'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream get].
	^ value! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 10/3/2011 14:53'!
getSmallInteger
	| hi lo |
	hi := stream get.
	lo := stream get.
	^ (hi bitShift: 8) + lo! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 10/3/2011 14:50'!
getType
	^ stream get! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!SMDecoder methodsFor: 'initialize-release' stamp: 'cwp 8/9/2011 15:15'!
initialize
	classes := OrderedCollection new! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:22'!
nextPut: aByte! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:53'!
readTwoBytes
	| hi lo |
	hi := stream get.
	lo := stream get.
	^ (hi bitShift: 8) bitOr: lo! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:53'!
readUtf8Character
	| value |
	value := stream get.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream get bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream get bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream get bitAnd: 63)].
			^ Unicode value: value ]! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 9/9/2010 20:13'!
stubNamed: aSymbol format: anInteger instVars: anArray
	self shouldBeImplemented! !

SMCodec subclass: #SMEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

SMEncoder class
	instanceVariableNames: 'stream'!

SMEncoder class
	instanceVariableNames: 'stream'!

!SMEncoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2011 16:05'!
stream: aStream
	^ self basicNew initializeWithStream: aStream! !

!SMEncoder methodsFor: 'public' stamp: 'cwp 8/26/2010 10:33'!
encode: anObject
	anObject encodeWith: self! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/7/2011 14:08'!
encodeArray: anArray
	self writeLibraryType.
	self writeArrayType.
	self encodeInteger: anArray size! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:09'!
encodeArrow: anArrow
	self writeArrowType.
	self encodeInteger: anArrow index! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 15:15'!
encodeBag: aBag
	self writeLibraryType.
	self writeBagType.! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/7/2011 14:08'!
encodeByteArray: anArray
	self writeLibraryType.
	self writeByteArrayType.
	self encodeInteger: anArray size! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 10/3/2011 15:03'!
encodeBytesFrom: anObject
	1 to: anObject byteSize do: 
		[:index | stream put: (anObject byteAt: index)]! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/9/2011 15:13'!
encodeClass: aClass
	| code |
	self writeClassType.
	classes 
		indexOf: aClass
		ifPresent: [:index | self encodeInteger: index]
		ifAbsent:
			[:index |
			self encodeSymbol: aClass name.
			self encodeInteger: (code := aClass smFormatCode).
			code < 3 ifTrue: 
				[ | names |
				names := aClass allInstVarNames.
				self encodeInteger: names size.
				names do: [ :ea | self encodeUtf8String: ea ] ] ]
		
! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 15:47'!
encodeContext: aMethodContext
	self writeContextType.
	self encodeInteger: aMethodContext method frameSize! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/7/2011 14:09'!
encodeDictionary: aDictionary
	self writeLibraryType.
	self writeDictionaryType.
	self encodeInteger: aDictionary size! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:11'!
encodeExternal: anInteger
	self writeExternalType.
	self encodeInteger: anInteger! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:39'!
encodeFloat: aFloat
	self writeFloatType.
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2)! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 16:11'!
encodeIdentityDictionary: aDictionary
	self writeLibraryType.
	self writeIdentityDictionaryType.
	self encodeInteger: aDictionary size! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 20:27'!
encodeInteger: anInteger
	anInteger < -65535 ifTrue: 
		[self writeLargeNegativeIntegerType.
		^ self writeLargeInteger: anInteger negated].
	anInteger < 0 ifTrue: 
		[self writeSmallNegativeIntegerType.
		^ self writeSmallInteger: anInteger negated].
	anInteger < 242 ifTrue: 
		[ ^ self writeTinyInteger: anInteger ].
	anInteger < 65535 ifTrue: 
		[self writeSmallPositiveIntegerType.
		^ self writeSmallInteger: anInteger].
	self writeLargePositiveIntegerType.
	self writeLargeInteger: anInteger! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 16:27'!
encodeInterval: anInterval 
	self writeLibraryType.
	self writeIntervalType.
	! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 15:06'!
encodeObject: anObject
	self writeObjectType.
	self encodeClass: anObject class.
	anObject class isVariable
		ifTrue: [ self encodeInteger: anObject basicSize ]! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/4/2011 11:29'!
encodeOrderedCollection: anOrderedCollection 
	self writeLibraryType.
	self writeOrderedCollectionType.! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 20:17'!
encodeSet: aSet
	self writeLibraryType.
	self writeSetType.! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 15:04'!
encodeSingleton: aBoolean
	| index |
	self writeLibraryType.
	index := #(nil true false) indexOf: aBoolean.
	stream put: index! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:09'!
encodeSymbol: aSymbol
	self writeSymbolType.
	self encodeInteger: aSymbol size.
	self writeUtf8String: aSymbol! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:11'!
encodeUtf16String: aString
	self writeUtf16Type.
	self encodeInteger: aString size.
	self writeUtf16String: aString! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:09'!
encodeUtf8String: aString
	self writeUtf8Type.
	self encodeInteger: aString size.
	self writeUtf8String: aString! !

!SMEncoder methodsFor: 'initialize-release' stamp: 'cwp 8/9/2011 14:46'!
initialize
	classes := IdentityDictionary new! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:03'!
write32BitInteger: anInteger
	stream		
		put: (anInteger bitShift: -24);
		put: ((anInteger bitShift: -16) bitAnd: 255);
		put: ((anInteger bitShift: -8) bitAnd: 255);
		put: (anInteger bitAnd: 255)! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:02'!
writeArrayType
	stream put: 4! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:03'!
writeArrowType
	stream put: 255! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:15'!
writeBagType
	stream put: 5! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:02'!
writeByteArrayType
	stream put: 6! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:00'!
writeClassType
	stream put: 253! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/4/2011 16:15'!
writeCompactType
	stream put: 241! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/4/2011 11:21'!
writeContextType
	stream put: 243! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:03'!
writeDictionaryType
	stream put: 7! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:02'!
writeExternalType
	stream put: 254! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:03'!
writeFloatType
	stream put: 244! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/4/2011 15:36'!
writeFourByteCode: anInteger
	| value |
	value := anInteger - 16r10000.
	stream put: ((value bitShift: -18) bitOr: 16rD8).
	stream put: ((value bitShift: -10) bitAnd: 16rFF).
	stream put: ((value bitShift: -8) bitOr: 16rDC).
	stream put: (value bitAnd: 16rFF).
	

! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 16:11'!
writeIdentityDictionaryType
	stream put: 8! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 16:25'!
writeIntervalType
	stream put: 9! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:04'!
writeLargeInteger: anInteger
	| byte size |
	size := (anInteger log: 256) floor + 1.
	self encodeInteger: size.
	(size - 1 to: 0 by: -1)
		do: [ :index | 
			byte := (anInteger bitShift: index * -8) bitAnd: 255.
			stream put: byte ]! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:04'!
writeLargeNegativeIntegerType
	stream put: 248! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:04'!
writeLargePositiveIntegerType
	stream put: 245! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/4/2011 16:15'!
writeLibraryType
	stream nextPut: 242! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:02'!
writeObjectType
	stream put: 252! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/4/2011 11:29'!
writeOrderedCollectionType
	stream put: 10! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:04'!
writeSetType
	stream put: 11! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:03'!
writeSmallInteger: anInteger
	stream put: (anInteger bitShift: -8).
	stream put: (anInteger bitAnd: 255). ! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:05'!
writeSmallNegativeIntegerType
	stream put: 247! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:02'!
writeSmallPositiveIntegerType
	stream put: 246! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:00'!
writeSymbolType
	stream put: 249! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:00'!
writeTinyInteger: anInteger
	stream put: anInteger! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:05'!
writeTwoByteCode: value
	stream put: (value bitShift: -8).
	stream put: (value bitAnd: 16rFF).! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:07'!
writeUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:05'!
writeUtf16Type
	stream put: 250! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 10/4/2011 16:14'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream put: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream put: ((value bitShift: -6) bitOr: 16rC0).
					stream put: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream put: ((value bitShift: -12) bitOr: 16rE0).
							stream put: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream put: ((value bitAnd: 16r3F) bitOr: 16r80)]
						ifFalse:
							[stream put: ((value bitShift: -18) bitOr: 16rF0).
							stream put: (((value bitShift: -12) bitAnd: 16r3F) bitOr: 16r80).
							stream put: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream put: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:06'!
writeUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:06'!
writeUtf8Type
	stream put: 251! !

Object subclass: #SMIndex
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

SMIndex subclass: #SMArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMArrow methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:36'!
encodeWith: anEncoder
	anEncoder encodeArrow: self! !

!SMArrow methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 12:05'!
materializeWith: aMaterializer
	^ aMaterializer materializeArrow: self! !

SMIndex subclass: #SMExternal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMExternal methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:39'!
encodeWith: anEncoder
	anEncoder encodeExternal: self! !

!SMExternal methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 12:44'!
materializeWith: aMaterializer
	^ aMaterializer materializeExternal: self! !

!SMIndex class methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
with: anInteger
	^ self basicNew
		initializeWithIndex: anInteger;
		yourself! !

!SMIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
encodeWith: anEncoder
	self subclassResponsibility! !

!SMIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
index
	^ index! !

!SMIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
initializeWithIndex: anInteger
	self initialize.
	index := anInteger.
	! !

Object subclass: #SMMaterializer
	instanceVariableNames: 'decoder internal external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMMaterializer class methodsFor: 'instance creation' stamp: 'cwp 8/9/2011 15:20'!
decoder: aDecoder
	^ self basicNew initializeWithDecoder: aDecoder! !

!SMMaterializer class methodsFor: 'materializing' stamp: 'cwp 10/3/2011 14:52'!
materialize: aByteArray
	^ self materializeFrom: aByteArray reading! !

!SMMaterializer class methodsFor: 'materializing' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!SMMaterializer class methodsFor: 'instance creation' stamp: 'cwp 8/9/2011 15:20'!
on: aReadStream
	^ self decoder: (SMDecoder stream: aReadStream)! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 8/26/2010 10:04'!
external: anArray 
	
	external := anArray! !

!SMMaterializer methodsFor: 'initialize-release' stamp: 'cwp 8/9/2011 15:18'!
initializeWithDecoder: aDecoder
	self initialize.
	decoder := aDecoder.
	internal := OrderedCollection new! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 8/9/2011 15:22'!
materialize
	| object |
	object := decoder decode.
	^ object materializeWith: self.
	! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeArray: array
	internal add: array.
	self readPointersInto: array.
	^ array! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:06'!
materializeArrow: anArrow
	^ internal at: anArrow index! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 10/3/2011 15:22'!
materializeBag: aBag 
	| size |
	size := self materialize.
	size timesRepeat: [aBag add: self materialize].
	^ aBag! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/10/2011 10:35'!
materializeBytes: aBytesObject
	internal add: aBytesObject.
	decoder getBytesInto: aBytesObject.
	^ aBytesObject! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeClass: aClass
	internal add: aClass.
	^ aClass! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeContext: aContext
	| sender pc stackp closure receiver method |
	internal add: aContext.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	stackp := self materialize.
	closure := self materialize.
	receiver := self materialize.
	aContext
		setSender: sender
			receiver: receiver
			method: method
			arguments: #();
		pc: pc;
		stackp: stackp;
		closure: closure.
	self readPointersInto: aContext.
	^ aContext! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeDictionary: aDictionary
	| size |
	internal add: aDictionary.
	size := self materialize.
	size timesRepeat: [ aDictionary at: self materialize put: self materialize ].
	^ aDictionary! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:44'!
materializeExternal: anExternal
	^ external at: anExternal index! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 10/3/2011 16:29'!
materializeInterval: anInterval 
	anInterval
		setFrom: self materialize
		to: self materialize
		by: self materialize.
	^ anInterval ! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeObject: anObject
	internal add: anObject.
	1 to: anObject class instSize do: [ :i | anObject instVarAt: i put: self materialize ].
	anObject class isVariable
		ifTrue: [ 
			anObject class isPointers
				ifTrue: [ self readPointersInto: anObject ]
				ifFalse: [ decoder getBytesInto: anObject ] ].
	^ anObject! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeSet: aSet
	| size |
	internal add: aSet.
	size := self materialize.
	size timesRepeat: [ aSet add: self materialize ].
	^ aSet! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 9/10/2010 00:03'!
readPointersInto: anObject 
	
	1	to: anObject basicSize
		do:	[ :i | anObject basicAt: i put: self materialize ]! !

Object subclass: #SMObjectWithExternalState
	instanceVariableNames: 'alpha beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
alpha
	^ alpha! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
beta
	^ beta! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:19'!
initialize
	alpha := ValueHolder new
		contents: 'alpha';
		yourself.
	
	beta := SMReference new
		value: 'beta';
		yourself! !

Object subclass: #SMReference
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMReference class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 10:40'!
to: anObject
	^ self new
		value: anObject;
		yourself! !

!SMReference methodsFor: 'serialization' stamp: 'cwp 8/26/2010 10:14'!
serializeWith: aSerializer
	^ aSerializer serializeReference: self! !

!SMReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:38'!
value
	^ value! !

!SMReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:40'!
value: anObject
	^ value := anObject! !

Object subclass: #SMSerializer
	instanceVariableNames: 'encoder external internal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/7/2011 16:07'!
encoder: anEncoder
	^ self basicNew initializeWithEncoder: anEncoder! !

!SMSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/7/2011 16:07'!
on: aWriteStream
	| anEncoder |
	anEncoder := SMEncoder stream: aWriteStream.
	^ self encoder: anEncoder! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 10/3/2011 14:56'!
serialize: anObject
	| ext stream |
	stream := (ByteArray new: 100) writing.
	ext := SMSerializer serialize: anObject on: stream.
	ext isEmpty ifFalse: [self error: 'This object refers to unserializable objects'].
	^ stream contents! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 10/3/2011 14:56'!
serialize: anObject external: aDictionary
	| stream external |
	stream := (ByteArray new: 100) writing.
	external := self serialize: anObject external: aDictionary on: stream.
	^ SMArchive bytes: stream contents external: external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject external: aDictionary on: aWriteStream
	^ (self on: aWriteStream)
		external: aDictionary;
		serialize: anObject;
		external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject on: aWriteStream
	^ self 
		serialize: anObject 
		external: IdentityDictionary new 
		on: aWriteStream! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 10/3/2011 16:21'!
encode: anObject
	encoder encode: anObject! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/26/2010 09:58'!
external
	| array |
	array := Array new: external size.
	external keysAndValuesDo:
		[:object :i | array at: i put: object].
	^ array! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/26/2010 09:58'!
external: aDictionary
	external := aDictionary! !

!SMSerializer methodsFor: 'initialize-release' stamp: 'cwp 8/6/2011 19:30'!
initializeWithEncoder: anEncoder
	encoder := anEncoder.
	internal := IdentityDictionary new.
	external := IdentityDictionary new! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/31/2008 21:21'!
serialize: anObject
	anObject serializeWith: self! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/9/2011 14:42'!
serialize: anObject with: aBlock
	internal 
		indexOf: anObject
		ifPresent: [ :id | encoder encode: (SMArrow with: id) ] 
		ifAbsent: [ :id | aBlock value ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 9/9/2010 23:14'!
serializeArray: anArray
	self serialize: anArray with: 
		[encoder encode: anArray.
		anArray do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 10/3/2011 15:18'!
serializeBag: aBag
	self serialize: aBag with: 
		[encoder encode: aBag.
		self serialize: aBag size.
		aBag do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/10/2011 10:54'!
serializeBytes: anObject
	encoder encode: anObject.
	encoder encodeBytesFrom: anObject    ! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/9/2011 15:23'!
serializeClass: aClass
	self 
		serialize: aClass 
		with: [encoder encode: aClass]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 10/3/2011 16:08'!
serializeDictionary: aDictionary
	self serialize: aDictionary with: 
		[encoder encode: aDictionary.
		aDictionary keys asArray sort do: 
			[ :key | 
			self serialize: key.
			self serialize: (aDictionary at: key) ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/9/2011 14:42'!
serializeExternal: anObject
	external 
		indexOf: anObject 
		do: [ :index | encoder encodeExternal: index ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:46'!
serializeFloat: aFloat
	encoder encodeFloat: aFloat! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 10/3/2011 16:06'!
serializeIdentityDictionary: aDictionary
	self serialize: aDictionary with: 
		[encoder encode: aDictionary.
		aDictionary keys asArray sort do: 
			[ :key | 
			self serialize: key.
			self serialize: (aDictionary at: key) ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:42'!
serializeInteger: anInteger
	encoder encodeInteger: anInteger! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/7/2011 15:49'!
serializeMethodContext: aContext
	self serialize: aContext with: 
		[encoder encodeContext: aContext.
		self serialize: aContext method.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext stackPtr.
		self serialize: aContext closure.
		self serialize: aContext receiver.
		self writePointersFrom: aContext ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 11:42'!
serializeObject: anObject
	self serialize: anObject with: 
		[encoder encode: anObject.
		1 to: anObject class instSize do: [ :i | self serialize: (anObject instVarAt: i) ].
		anObject class isVariable ifTrue: 
			[anObject class isPointers
				ifTrue: [ self writePointersFrom: anObject ]
				ifFalse: [ encoder encodeBytesFrom: anObject ] ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/6/2011 17:25'!
serializeReference: aReference
	self serialize: aReference with:
		[encoder encodeObject: aReference.
		self serializeExternal: aReference value]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 10/4/2011 11:33'!
serializeSet: aSet
	self serialize: aSet with: 
		[encoder encode: aSet.
		self serialize: aSet size.
		aSet do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:57'!
serializeSingleton: aBoolean
	encoder encodeSingleton: aBoolean! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:58'!
serializeSymbol: aSymbol
	encoder encodeSymbol: aSymbol! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 17:00'!
serializeUtf16String: aString
	encoder encodeUtf16String: aString! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:59'!
serializeUtf8String: aString
	encoder encodeUtf8String: aString! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/9/2010 23:55'!
writePointersFrom: anObject
	1 to: anObject basicSize do: [ :i | self serialize: (anObject basicAt: i)]
	! !

!Array methodsFor: '*esandem-dispatching' stamp: 'cwp 9/9/2010 23:18'!
encodeWith: anEncoder
	^ anEncoder encodeArray: self! !

!Array methodsFor: '*esandem-dispatching' stamp: 'cwp 9/9/2010 23:22'!
materializeWith: aMaterializer
	^ aMaterializer materializeArray: self! !

!Array methodsFor: '*esandem-dispatching' stamp: 'cwp 9/9/2010 23:22'!
serializeWith: aSerializer
	aSerializer serializeArray: self! !

!Set methodsFor: '*esandem-dispatch' stamp: 'cwp 10/4/2011 11:46'!
encodeWith: anEncoder
	anEncoder encodeSet: self! !

!Set methodsFor: '*esandem-dispatch' stamp: 'cwp 10/3/2011 15:20'!
materializeWith: aMaterializer
	^ aMaterializer materializeSet: self! !

!Set methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:24'!
serializeWith: aSerializer
	^ aSerializer serializeSet: self! !

!Symbol methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 00:04'!
serializeWith: aSerializer
	aSerializer serializeSymbol: self! !

!OrderedCollection methodsFor: '*esandem-dispatching' stamp: 'cwp 10/4/2011 11:28'!
encodeWith: anEncoder
	anEncoder encodeOrderedCollection: self! !

!OrderedCollection methodsFor: '*esandem-dispatching' stamp: 'cwp 10/4/2011 11:34'!
materializeWith: aMaterializer
	^ aMaterializer materializeSet: self    ! !

!OrderedCollection methodsFor: '*esandem-dispatching' stamp: 'cwp 10/4/2011 11:34'!
serializeWith: aSerializer
	aSerializer serializeSet: self  ! !

!WideString methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 21:49'!
serializeWith: aSerializer
	aSerializer serializeUtf16String: self! !

!Interval methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 16:18'!
encodeWith: anEncoder
	^ anEncoder encodeInterval: self! !

!Interval methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 16:17'!
materializeWith: aMaterializer
	^ aMaterializer materializeInterval: self! !

!Interval methodsFor: '*esandem-dispatching' stamp: 'cwp 10/3/2011 16:24'!
serializeWith: aSerializer
	aSerializer
		encode: self;
		serialize: start;
		serialize: stop;
		serialize: step! !

!Boolean methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:08'!
materializeWith: aMaterializer
	^ self! !

!Boolean methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:08'!
serializeWith: aSerializer
	aSerializer serializeSingleton: self! !

!ContextPart class methodsFor: '*esandem-creation' stamp: 'cwp 8/7/2011 15:44'!
smBasicNew: anInteger
	^super basicNew: anInteger! !

TestCase subclass: #SMCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMCodecTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/3/2011 14:50'!
testClassCaching
	| encoder stream first second |
	stream := ByteArray new writing.
	encoder := SMEncoder stream: stream.
	encoder encode: self class.
	first := stream position.
	encoder := encoder encode: self class.
	second := stream position.
	
	self assert: second < (first * 2).! !

!SMCodecTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/3/2011 14:50'!
testClassIdentity
	| encoder stream first second decoder |
	stream := ByteArray new writing.
	encoder := SMEncoder stream: stream.
	encoder encode: self class.
	encoder encode: self class.
	
	stream := stream conclusion reading.
	decoder := SMDecoder stream: stream.
	first := decoder decode.
	second := decoder decode.
	self assert: first == self class.
	self assert: second == self class.! !

TestCase subclass: #SMMaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMMaterializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:09'!
isAbstract
	^ self name = #SMMaterializerTest! !

!SMMaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:09'!
assert: aByteArray yields: expected
	| actual |
	actual := SMMaterializer materialize: aByteArray.
	self assert: actual = expected! !

!SMMaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:12'!
stringFromUnicode: anArray 
	| stringClass string |
	stringClass := (anArray anySatisfy: [:code | code > 255])
		ifTrue: [WideString]
		ifFalse: [ByteString].
	string := stringClass new: anArray size.
	1
		to: anArray size
		do:	[:index | 
			string
				at: index
				put: (Unicode value: (anArray at: index))].
	
	^ string! !

SMMaterializerTest subclass: #SMUtf16MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMUtf16MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:22'!
testAboriginal
	self
		assert: #[250 3 20 1 20 2 20 3]
		yields: (self stringFromUnicode: #(16r1401 16r1402 16r1403))! !

!SMUtf16MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:35'!
testAscii
	self
		assert: #[250 3 0 97 0 98 0 99]
		yields: 'abc'! !

!SMUtf16MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:35'!
testLatin
	self
		assert: #[250 3 0 225 0 98 0 99]
		yields: (self stringFromUnicode: #(225 98 99))! !

SMMaterializerTest subclass: #SMUtf8MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:21'!
testAboriginal
	self
		assert: #[251 3 225 144 129 225 144 130 225 144 131]
		yields: (self stringFromUnicode: #(16r1401 16r1402 16r1403))! !

!SMUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:22'!
testAscii
	self
		assert: #[251 3 97 98 99]
		yields: 'abc'! !

!SMUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:14'!
testLatin
	self
		assert: #[251 3 195 161 98 99]
		yields: (self stringFromUnicode: #(225 98 99))! !

TestCase subclass: #SMReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/6/2011 17:17'!
testCreationHolding
	| ref |
	ref := SMReference to: self.
	self assert: ref value == self! !

!SMReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2011 14:56'!
testIdentityPreservation
	| actual original one two |
	one := Object new.
	two := Object new.
	original := {SMReference to: one. SMReference to: two}.
	actual := original serialize materialize.
	self assert: actual first value == one.
	self assert: actual second value == two.! !

!SMReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/6/2011 17:17'!
testValueHolding
	| ref |
	ref := SMReference to: nil.
	ref value: self.
	self assert: ref value == self! !

TestCase subclass: #SMRoundTripTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMRoundTripTest methodsFor: 'support' stamp: 'cwp 9/2/2008 00:30'!
assertEqualityOf: expected
	^ self 
		assertEquivalenceOf: expected 
		with: [:actual | actual = expected]! !

!SMRoundTripTest methodsFor: 'support' stamp: 'cwp 9/5/2008 07:55'!
assertEquivalenceOf: expected with: aBlock
	self 
		examineResultOf: expected 
		with: 
			[:actual | 
			self assert: (aBlock value: actual)]! !

!SMRoundTripTest methodsFor: 'support' stamp: 'cwp 8/31/2008 23:00'!
assertIdentityOf: expected
	^ self
		assertEquivalenceOf: expected
		with: [:actual | actual == expected]! !

!SMRoundTripTest methodsFor: 'support' stamp: 'cwp 9/8/2008 21:17'!
examineResultOf: expected with: aBlock
	| actual archive |
	archive := expected serialize.
	actual := archive materialize.
	aBlock value: actual! !

!SMRoundTripTest methodsFor: 'support' stamp: 'cwp 8/7/2011 15:21'!
getContext
	^ thisContext! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 19:13'!
testArchive
	| archive |
	archive := 3 serialize.
	self assert: archive materialize = 3! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 20:43'!
testArray
	self assertEqualityOf: #(1 'two' 3.0)! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/3/2011 15:12'!
testBag
	| bag |
	bag := Bag new.
	bag addAll: #(1 2 2 3).
	self assertEqualityOf: bag! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:24'!
testByte
	self assertEqualityOf: 42! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/10/2011 10:33'!
testByteArray
	| bytes |
	bytes := (0 to: 255) asByteArray.
	self assertEqualityOf: bytes! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 07:09'!
testBytesObject
	self assertEqualityOf: UUID new! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 23:02'!
testClass
	self assertIdentityOf: self class! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/23/2008 21:08'!
testCompiledMethod
	self assertIdentityOf: thisContext method.
	! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:57'!
testCyclicalReferenceArray
	| object |
	object := Array new: 1.
	object at: 1 put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual first == actual]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:06'!
testCyclicalReferenceDictionary
	| object |
	object := Dictionary new: 1.
	object at: #one put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | (actual at: #one) == actual]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:16'!
testCyclicalReferenceObject
	| object |
	object := ValueHolder new.
	object contents: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual contents == actual]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:58'!
testCyclicalReferenceSet
	| object |
	object := Set new: 1.
	object add: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual anyOne == actual]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:22'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3;
		yourself.
	self assertEqualityOf: dict! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/26/2010 20:19'!
testDigest
	| archive |
	archive := 3 serialize.
	self assert: archive digest = '9842926af7ca0a8cca12604f945414f07b01e13d'! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/26/2010 10:22'!
testExternalObject
	| object |
	object := SMObjectWithExternalState new.
	self 
		assertEquivalenceOf: object
		with: 
			[:actual |
			actual alpha ~~ object alpha
				and: [actual beta value == object beta value]]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testFalse
	self assertIdentityOf: false! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:50'!
testFloat
	self assertEqualityOf: 3.4! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/9/2011 14:53'!
testIdentity
	| a original |
	a := Object new.
	original := {a. a}.
	self 
		examineResultOf: original
		with: 
			[:result | 
			self deny: result == original.
			self deny: result first == a.
			self deny: result second == a.
			self assert: result first == result second]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/3/2011 16:04'!
testIdentityDictionary
	| id |
	id := IdentityDictionary new.
	id at: #one put: 1.
	self 
		assertEquivalenceOf: id 
		with: 
			[ :actual | 
			actual class = id class.
			actual = id ]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/3/2011 16:15'!
testInterval
	| interval |
	interval := 1 to: 10.
	self
		examineResultOf: interval
		with: 
			[ :actual | 
			self assert: actual class = interval class.
			self assert: actual = interval ]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargeNegativeInteger
	self assertEqualityOf: -65536! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargePositiveInteger
	self assertEqualityOf: 65536! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:15'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/7/2011 15:56'!
testMethodContext
	| original |
	original := self getContext.
	self examineResultOf: original with:   
		[:actual |
		self assert: original method == actual method.
		self assert: original sender isNil.
		self assert: original pc = actual pc.
		self assert: original method = actual method.
		self assert: original closure = actual closure.
		self assert: original receiver selector = actual receiver selector.
		self assert: original receiver timeoutForTest = actual receiver timeoutForTest].
		! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:59'!
testMultiString
	| ws |
	ws := WideString fromString: 'abc'.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testNil
	self assertIdentityOf: nil! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 01:13'!
testObject
	self 
		assertEquivalenceOf: self 
		with: 
			[:actual |
			actual class = self class
				and: [actual selector = self selector]]! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/4/2011 11:26'!
testOrderedCollection
	self assertEqualityOf: #(1 'two' 3.0) asOrderedCollection! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/6/2011 17:22'!
testReference
	| expected |
	expected := SMReference to: self.
	self examineResultOf: expected with:
		[:actual |
		self deny: expected == actual.
		self assert: expected value == actual value]
	! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:06'!
testSet
	self assertEqualityOf: #(1 'two' 3.0) asSet! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallNegativeInteger
	self assertEqualityOf: -300! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallPositiveInteger
	self assertEqualityOf: 300! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testString
	self assertEqualityOf: 'abc'.! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/9/2010 22:50'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 00:04'!
testSymbol
	self assertIdentityOf: #one! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 2/16/2011 10:57'!
testTinyInteger
	self assertEqualityOf: 7! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:26'!
testTrue
	self assertIdentityOf: true! !

!SMRoundTripTest methodsFor: 'tests' stamp: 'cwp 7/14/2010 11:04'!
testVariablePointerObject
	| expected |
	expected := (SparseLargeTable new: 3)
		at: 1 put: $a;
		at: 2 put: $b;
		at: 3 put: $c;
		yourself.

	self 
		assertEquivalenceOf: expected 
		with: 
			[:actual |
			actual class = expected class
				and: [actual = expected]]! !

TestCase subclass: #SMSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMSerializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:11'!
isAbstract
	^ self name = #SMSerializerTest! !

!SMSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2008 23:49'!
assert: actual equals: expected
	| limit |
	limit := actual size min: expected size.
	1 to: limit do: [:index | self assert: (actual at: index) = (expected at: index)].
	self assert: actual size = expected size! !

!SMSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/3/2011 15:06'!
assert: anObject yields: expected 
	| stream actual |
	stream := ByteArray new writing.
	self serialize: anObject on: stream.
	actual := stream contents.
	self 
		assert: actual
		equals: expected! !

!SMSerializerTest methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 18:54'!
serialize: anObject on: aStream
	self subclassResponsibility! !

!SMSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:49'!
stringFromUnicode: anArray 
	| stringClass string |
	stringClass := (anArray anySatisfy: [:code | code > 255])
		ifTrue: [WideString]
		ifFalse: [ByteString].
	string := stringClass new: anArray size.
	1
		to: anArray size
		do:	[:index | 
			string
				at: index
				put: (Unicode value: (anArray at: index))].
	
	^ string! !

SMSerializerTest subclass: #SMUtf16SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
serialize: anObject on: aStream
	| serializer |
	serializer := SMSerializer on: aStream.
	serializer serializeUtf16String: anObject.! !

!SMUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testAboriginal
	self 
		assert: (self stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[250 3 20 1 20 2 20 3]! !

!SMUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:26'!
testAscii
	self 
		assert: 'abc' 
		yields: #[250 3 0 97 0 98 0 99]! !

!SMUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2011 15:35'!
testGClef
	self 
		assert: (self stringFromUnicode: #(16r1D11E))
		yields: #[250 1 216 52 221 30]
		
	! !

!SMUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testLatin
	self 
		assert: (self stringFromUnicode: #(225 98 99))
		yields: #[250 3 0 225 0 98 0 99]
	! !

SMSerializerTest subclass: #SMUtf8SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
serialize: anObject on: aStream
	| serializer |
	serializer := SMSerializer on: aStream.
	serializer serializeUtf8String: anObject.! !

!SMUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testAboriginal
	self 
		assert: (self stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[251 3 225 144 129 225 144 130 225 144 131]! !

!SMUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:24'!
testAscii
	self assert: 'abc' yields: #(251 3 97 98 99)! !

!SMUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2011 16:06'!
testGClef
	self 
		assert: (self stringFromUnicode: #(16r1D11E))
		yields: #[251 1 240 157 132 158]
		
	! !

!SMUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testLatin
	self 
		assert: (self stringFromUnicode: #(225 98 99)) 
		yields: #[251 3 195 161 98 99]! !

!ByteArray methodsFor: '*esandem-dispatching' stamp: 'cwp 9/9/2010 23:28'!
encodeWith: anEncoder
	^ self class = ByteArray 
		ifTrue: [anEncoder encodeByteArray: self]
		ifFalse: [super encodeWith: anEncoder]! !

!ByteArray methodsFor: '*esandem-dispatching' stamp: 'cwp 8/10/2011 10:35'!
materializeWith: aMaterializer
	^ aMaterializer materializeBytes: self! !

!ByteArray methodsFor: '*esandem-dispatching' stamp: 'cwp 8/10/2011 10:43'!
serializeWith: aSerializer
	aSerializer serializeBytes: self! !
